<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2003 Administrator (admin@email.test)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'SourceOptimization' for the 'SourceOpt' extension.
 *
 * @author        Boris Nicolai <boris.nicolai@andavida.com>
 * @author        Bernd Hanisch <bh@cocon.net>         
 *                   added some bugfixes circ. javascripts
 * @author        Tim Lochmller <webmaster [at] fruit-lab [dot] de>
 *                   added some functionality 
 * @author        Dr. Ronald P. Steiner  <Ronald.Steiner [at] googlemail [dot] com>         
 *                   Change: names of the objects with no "_" but with humps like normally in Typo3
 *                   Change: default TS includes some Typo3-core options that help cleaning the code 
 *                   Change: TYPO3 Copyright stays in the code even when all comments are removed. It still can be removed by deleting one line in the TS default configuration.  
 *                   New: moveInlineCss, moveInlineCss.file = cause it does in some regard a better job than config.inlineStyle2TempFile               
 *                   New: removeComments = 3 (only Head), 
 *                   New: keepComment = an array to define which comments should be saved from removeComments (useful for indexed_search),
 *                   New:  headerComment = an additional header comment
 *                   New: formatHtml = Formats the code beautiful and easy readable. 
 *                   Bugfix: conflicts with some combination of options  
 * @author	  Daniel Wegener <daniel[at]avithan.de>
 *		  Bugfix: FormatHTML 4 will no longer eat spaces before and after inline-tags (changed: killLineBreaks does no longer trim(), just killing linebreaks) 
 *		  New: MoveInlineCSS supports the field MoveInlineCSS.media as string/stdwrap, resulting as attribute like <link rel="stylesheet" href="xyz.css" media="string text" />.
 *		  Bugfix: The starting xml-tag of XHTML-Documents will no longer be handled as (unclosed) box-element.
 *		  Change: Did some code-cleanup.
 * @author	Tilman Moser <moser@w3-dev.de>
 *		  Bugfix: FormatHTML: Changed the tab-increase-pattern from <col* to <col\s*, so that you no longer get a tab increase on <colgroup*>.
 *		  Bugfix/Change: FormatHTML ignores now Comments / Styles and Scripts, since Scripts intended to break, when you deal with html-Code as Strings in Javascripts.
 *		  New: If tabSize is specified in conf-Array, tab is n x Space, else it's \t
 */

require_once (PATH_tslib."class.tslib_pibase.php");
require_once (PATH_tslib."class.tslib_content.php");


class tx_sourceopt_pi1 extends tslib_pibase {
        
	var $prefixId = "tx_sourceopt_pi1";                // Same as class name
	var $scriptRelPath = "pi1/class.tx_sourceopt_pi1.php";        // Path to this script relative to the extension dir.
	var $extKey = "sourceopt";        // The extension key.
        
	var $content;   // HTML code of the page
	var $body;      // HTML of the body
	var $head;      // HTML of the head
	var $conf;      // TypoScript Configuration for theis extension
        
	function main (&$content, $conf) {

		// initialise    
        #$GLOBALS["TSFE"]->set_no_cache();   // cache of for debugging
        $this->content =& $content;
        $this->conf = $conf;
    	switch (TYPO3_OS) {  // set newline
        	case "WIN" : $this->newline = "\r\n"; break;
            default : $this->newline = "\n";
        }
        $this->tab = "\t";
		if ($this->conf['formatHtml.']['tabSize'] && is_numeric($this->conf['formatHtml.']['tabSize'])) {
			$this->tab = str_pad('', $this->conf['formatHtml.']['tabSize'], ' ');
		}
				
        // switch through wished modifications; sorting should not be changed
        if ($conf['enabled'] == 1) {                              
                        // split <html> in <body> and <head>
                        preg_match ("/<body.+?>.*<\/body>/is", $this->content, $match_body);
                        $this->body = $match_body[0];
                        preg_match ("/<head>.*<\/head>/is", $this->content, $match_head);
                        $this->head = $match_head[0];  
                        
                        // work with <head>                                                                             
                        if ($conf['removeGenerator'] == 1)               
                                $this->removeGenerator ();
                        if ($conf['removeLinkSchema'] == 1) 
                                $this->removeLinkSchema ();
                        if ($conf['removeComments'] == 3 || $conf['removeComments'] == 2) 
                                $this->removeComments ($this->head);    
                        if ($conf['headerComment'] != "") 
                                $this->includeHeaderComment(); 
                        ### old ###
                        if ($conf['moveInlineCss'] == 1)
                                $this->moveInlineCss ();
                        if ($conf['trimLines'] == 2)
                                $this->trimLines ($this->head);
                        if ($conf['removeEmptyLines'] == 2)
                                $this->removeEmptyLines ($this->head);
                        if ($conf['removeNewLines'] == 2)
                                $this->removeNewLines ($this->head);
                        ### old end ###                    
						    
                        // work with <body>                                                                                     
                        if ($conf['removeEmptyAltAtr'] == 1)       
                                $this->removeEmptyAltAtr ();  
                        if ($conf['removeRealUrlBrokenRootLink'] == 1) 
                                $this->removeRealUrlBrokenRootLink (); 
                        if (!empty ($conf['replaceClearGif']))           
                                $this->replaceClearGif ();                                    
						if ($conf['removeComments'] == 1 || $conf['removeComments'] == 2)  
                                $this->removeComments ($this->body);
                        ## old ###
                        if ($conf['trimLines'] == 1 || $conf['trimLines'] == 2) 
                                $this->trimLines ($this->body); 
                        if ($conf['removeEmptyLines'] == 1 || $conf['removeEmptyLines'] == 2) 
                                $this->removeEmptyLines ($this->body); 
                        if ($conf['removeNewLines'] == 1 || $conf['removeNewLines'] == 2) 
                                $this->removeNewLines ($this->body);  
                        # old end ###                        

                        // work in <body> and <head>
                        if ($conf['removeBlurScript'] == 1)          // in: $this->head und $this->body
                                $this->removeBlurScript ();                            
                                
                       // recombine <body> and <head> to <html> ... problem with "$" so str_replace fix
						$this->content = preg_replace ("/<body(.*)>(.*)<\/body>/Usi", str_replace('$', '\\$', $this->body), $this->content);
						$this->content = preg_replace ("/<head>(.*)<\/head>/si", str_replace('$', '\\$', $this->head), $this->content);

                        // work in <html>
                        # old #########
						if (!empty ($conf['replaceDoctype']))  
                                $this->replaceDoctype ();
                        if ($conf['alternateHtmlXhtmlLanguage']) 
                                $this->alternateHtmlXhtmlLanguage ();
                        #### old end #####
                        if ($conf['emtpyBodyTag'] == 1) 
                                $this->emtpyBodyTag ();
                        if ($conf['removeScriptCdata'] == 1)   
                                $this->removeScriptCdata ();  
                        if ($conf['formatHtml'])
                                $this->formatHtml($this->content);
		}            
	}   

##################################################################
### small functions       ########################################
##################################################################       
		// small head functions
        function removeGenerator () {
                $this->head = preg_replace ("/<meta name=\"?generator\"?.+?>/is", "", $this->head);
        }
        function removeLinkSchema () {
                $this->head = preg_replace ("/<link rel=\"?schema.dc\"?.+?>/is", "", $this->head);
        }
        function includeHeaderComment () {
            $this->head =  preg_replace_callback('/<meta http-equiv(.*)>/Usi',array($this,'includeHeaderComment_callback'),$this->head);
        }  
        // help function for "includeHeaderComment" preg_replace_callback
        function includeHeaderComment_callback($match) {
             return trim($match[0].$this->newline.$this->tab.$this->tab."<!-- ".$this->conf['headerComment']."-->");
        }
        
        // small body functions
        function replaceClearGif () {
                $this->body = str_replace ("clear.gif", $this->conf['replace_clear_gif'], $this->body);
        }
        function removeEmptyAltAtr () {
                $this->body = str_replace ("alt=\"\"", "", $this->body);
        }
        function removeRealUrlBrokenRootLink () {
                $this->body = str_replace ('href=".html"', 'href=""', $this->body);
        }
        
        // small content functions
        function removeScriptCdata () {
                $pattern = "/<script type=\"text\/javascript\">.+CDATA.+<\/script>/is";
                $this->content = preg_replace ($pattern, "", $this->content);
        }       
		 
        /**
        * Typo adds to each page a small script: 
        *                <script language="javascript">
        *                <!--
        *                browserName = navigator.appName;
        *                browserVer = parseInt(navigator.appVersion);
        *                var msie4 = (browserName == "Microsoft Internet Explorer" && browserVer >= 4);
        *                if ((browserName == "Netscape" && browserVer >= 3) || msie4 || browserName=="Konqueror") {version = "n3";} else {version = "n2";}
        *                function blurLink(theObject){
        *                if (msie4){theObject.blur();}
        *                }
        *                // -->
        *                </script>
        * Obviously used for client-side browserdetection - but thats not necessary if your page doesn't use JS
        * 
        * @parama     nothing
        * @return     nothing                        
        */
        function removeBlurScript () {
                $pattern = "/<script (type=\"text\/javascript\"|language=\"javascript\")>.+?Konqueror.+function blurLink.+theObject.blur.+?<\/script>/is";
                // used a REX instead of str_replace cause str_replace didn't work reliably
                $this->head = preg_replace ($pattern, "", $this->head);
                $this->body = str_replace (" onFocus=\"blurLink(this);\"", "", $this->body);
                $this->body = str_replace (" onfocus=\"blurLink(this);\"", "", $this->body);
        }

        /**
        * remove all attributes from the body-tag
        * 
        * @param     nothing
        * @return    nothing                        
        */
        function emtpyBodyTag () {
                $this->content = preg_replace ("/<body.*>/Usi", "<body>", $this->content);
        }
##################################################################

##################################################################
### removeComments          ######################################
##################################################################
	/**
	 * Remove all comments that are not specified with keepComment
	 *         
	 * @param    string-reff     html-code
	 * @return   nothing                
	 */
	function removeComments (&$html) {
		preg_match_all("/(?s)((<!--.*?-->)|(<[ \n\r]*style[^>]*>.*?<[ \n\r]*\/style[^>]*>)|(<[ \n\r]*script[^>]*>.*?<[ \n\r]*\/script[^>]*>))/im", $html, $matches);	// match all styles, scripts and comments
		for($i=0; $i<count($matches[0]); $i++) {
			if (preg_match("/^\<\!\-\-(.*?)\-\-\>$/usi",$matches[0][$i])    // if a comment
				&& !$this->keepComment($matches[0][$i])) {					// and not defined in keepComment
				$html = str_replace($matches[0][$i], "", $html);
				#$html = str_replace($matches[0][$i], '<!-- REMOVED: '.urlencode($matches[0][$i]).' this will be replaced with: '.$matches[0][$i] .' -->', $html); 
			}
		}
    }   

	/**
	 * help function to formatHtml		
	 * check if a comment is defined to be kept
	 * 
	 * $this->conf[keepCommen]
	 *         
	 * @param    string	      comment
	 * @return   boolean               
	 */    
	function keepComment($commentHtml) {
		if ($this->conf['removeComments.']['keep.']) {
			$commentHtml = str_replace ("<!--","",$commentHtml);
			$commentHtml = str_replace ("-->","",$commentHtml);
			$commentHtml = trim($commentHtml);
			foreach($this->conf['removeComments.']['keep.'] as $pattern) {
				if(preg_match($pattern,$commentHtml)) {
					return true;
				}
           	}
        }
		else {
			return false;
		}
    }
##################################################################

##################################################################
### FormatHtml       #############################################
##################################################################	        
	/**
     * formats the (X)HTML code: 
     *  - taps according to the hirarchy of the tags
     *  - removes empty spaces between tags
     *  - removes linebreaks within tags (spares where necessary: pre, textarea, comments, ..)            
     *  choose from five options: 
     *    0 => off
     *    1 => no line break at all  (code in one line)
     *    2 => minimalistic line breaks (structure defining box-elements)
     *    3 => aesthetic line breaks (important box-elements)
     *    4 => logic line breaks (all box-elements)
     *    5 => max line breaks (all elements)              
     * 
     * @param     string-reff     html-Code
     * @return    nothing                        
     */  
    function formatHtml(&$html) {
		 // Save original formated comments, styles and java-scripts & replace them with markers
		preg_match_all("/(?s)((<!--.*?-->)|(<[ \n\r]*style[^>]*>.*?<[ \n\r]*\/style[^>]*>)|(<[ \n\r]*script[^>]*>.*?<[ \n\r]*\/script[^>]*>))/im", $html, $matches);
		$no_format = $matches[0]; // do not format these block elements
		for($i=0; $i<count($no_format); $i++) {
			$html = str_replace($no_format[$i], "\n<!-- ELEMENT $i -->", $html);
		}
		
		// define box elements for formatting
    	$trueBoxElements = 'address|blockquote|center|dir|div|dl|fieldset|form|h1|h2|h3|h4|h5|h6|hr|isindex|menu|noframes|noscript|ol|p|pre|table|ul';
		$functionalBoxElements = 'dd|dt|frameset|li|tbody|td|tfoot|th|thead|tr|colgroup';
        $usableBoxElements = 'applet|button|del|iframe|ins|map|object|script';
        $imagineBoxElements = 'html|body|head|meta|title|link|script|base|!--';
        $allBoxLikeElements = '(?>'.$trueBoxElements.'|'.$functionalBoxElements.'|'.$usableBoxElements.'|'.$imagineBoxElements.')';
		$esteticBoxLikeElements   = '(?>html|head|body|meta name|title|div|table|h1|h2|h3|h4|h5|h6|p|form|pre|center|!--)';
        $structureBoxLikeElements = '(?>html|head|body|div|!--)';
			
		// split html into it's elements	
		$html_array_temp=preg_split('/(<(?:[^<>]+(?:"[^"]*"|\'[^\']*\')?)+>)/',$html,-1,PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);  
		// remove empty lines
		$html_array = array();
        $z = 0;
    	for ($x=0;$x<count($html_array_temp);$x++) {
        	if (trim($html_array_temp[$x]) != "") { 
            	$html_array[$z] = $html_array_temp[$x];
                $z++;
            }
        }
		
		// rebuild html	
        $html='';
    	$tabs=0;		
        for ($x=0;$x<count($html_array);$x++) {               
            
			// check if the element should stand in a new line
			$newline = false;
		    if (substr($html_array[$x-1],0,5)=='<?xml') {
				$newline = true;
			}
            elseif ($this->conf['formatHtml'] == 2 && (  // minimalistic line break
            	# this element has a line break before itself
                preg_match('/<'.$structureBoxLikeElements.'(.*)>/Usi',$html_array[$x]) ||
                preg_match('/<'.$structureBoxLikeElements.'(.*) \/>/Usi',$html_array[$x]) ||
                # one element before is a element that has a line break after
                preg_match('/<\/'.$structureBoxLikeElements.'(.*)>/Usi',$html_array[$x-1]) ||
                substr($html_array[$x-1],0,4)=='<!--' ||
                preg_match('/<'.$structureBoxLikeElements.'(.*) \/>/Usi',$html_array[$x-1])                                           
                )) 
            	$newline = true;                    
            elseif ($this->conf['formatHtml'] == 3 && (  // aestetic line break
            	# this element has a line break before itself
                preg_match('/<'.$esteticBoxLikeElements.'(.*)>/Usi',$html_array[$x]) ||
                preg_match('/<'.$esteticBoxLikeElements.'(.*) \/>/Usi',$html_array[$x]) ||
                # one element before is a element that has a line break after
                preg_match('/<\/'.$esteticBoxLikeElements.'(.*)>/Usi',$html_array[$x-1]) ||
                substr($html_array[$x-1],0,4)=='<!--' ||
                preg_match('/<'.$esteticBoxLikeElements.'(.*) \/>/Usi',$html_array[$x-1])                                           
            )) 
            	$newline = true;
            elseif ($this->conf['formatHtml'] >= 4 && (  // logical line break
            	# this element has a line break before itself
                preg_match('/<'.$allBoxLikeElements.'(.*)>/Usi',$html_array[$x]) ||
                preg_match('/<'.$allBoxLikeElements.'(.*) \/>/Usi',$html_array[$x]) ||
                # one element before is a element that has a line break after
                preg_match('/<\/'.$allBoxLikeElements.'(.*)>/Usi',$html_array[$x-1]) ||
                substr($html_array[$x-1],0,4)=='<!--' ||
                preg_match('/<'.$allBoxLikeElements.'(.*) \/>/Usi',$html_array[$x-1])                                              
                )) 
                $newline = true;   
            
            // count down a tab
			if (substr($html_array[$x],0,2)=='</') {
            	$tabs--;
            }
			
			// add tabs and line breaks in front of the current tag
            if ($newline) {
            	$html .= $this->newline;
                for ($y=0;$y<$tabs;$y++) {
                    $html.= $this->tab;
                }
            }
		    
		    // remove white spaces and line breaks and add current tag to the html-string
            if (substr($html_array[$x-1],0,4)=='<pre'   			// remove white space after line ending in PRE / TEXTAREA / comment
				|| substr($html_array[$x-1],0,9)=='<textarea'
				|| substr($html_array[$x-1],0,4)=='<!--') {
            	$html .= $this->rTrimLines($html_array[$x]);
            }
            elseif (substr($html_array[$x],0,9)=='<![CDATA['   		// remove multiple white space in CDATA / XML 
            	|| substr($html_array[$x],0,5)=='<?xml') {
                $html .= $this->killWhiteSpace($html_array[$x]);
            }
            else {  												// remove all line breaks
            	$html .= $this->killLineBreaks($html_array[$x]);
			}                       
                    
            // count up a tab
			if (substr($html_array[$x],0,1)=='<' && substr($html_array[$x],1,1)!='/') {
            	if (substr($html_array[$x],1,1)!=' ' &&
                    substr($html_array[$x],1,3)!='img' && 
                    substr($html_array[$x],1,2)!='br' && 
                    substr($html_array[$x],1,2)!='hr' && 
                    substr($html_array[$x],1,5)!='input' && 
                    substr($html_array[$x],1,4)!='link' && 
                    substr($html_array[$x],1,4)!='meta' && 
                    substr($html_array[$x],1,4)!='col ' && 
                    substr($html_array[$x],1,5)!='frame' && 
                    substr($html_array[$x],1,7)!='isindex' && 
                    substr($html_array[$x],1,5)!='param' && 
                    substr($html_array[$x],1,4)!='area' && 
                    substr($html_array[$x],1,4)!='base'  && 
                    substr($html_array[$x],0,2)!='<!' &&
				    substr($html_array[$x],0,5)!='<?xml') {
                    $tabs++;
                }
			}
        }

		// Restore saved comments, styles and java-scripts
		for($i=0; $i<count($no_format); $i++) {
			$no_format[$i] = $this->rTrimLines($no_format[$i]);  // remove white space after line ending
			$html = str_replace("<!-- ELEMENT $i -->", $no_format[$i], $html);
		}
		
		// include debug comment at the end
		if ($tabs!=0 && $this->conf['formatHtml.']['debugComment'] == 1) {
        	$html.='<!--'.$tabs." open elements found-->\r\n";
        }
	}

	/**
	 * help function to formatHtml (and removeNewLines)
     *  removes ALL line breaks and multiple white space
     * 
     * @param     string     html-Code
     * @return    string     html-Code                        
     */  
	function killLineBreaks ($html) {
		$html = $this->convNlOs($html);
		$html = str_replace ($this->newline, "", $html);
		// remove empty spaces between tags
        $html = preg_replace ("/>\s*</ism", "><", $html);
        // remove double empty spaces
        $html = preg_replace('/\s\s+/', ' ', $html);
		return $html;
	}

	/**
	 * help function to formatHtml
	 * removes multiple white space, keeps line breaks 
     * 
     * @param     string     html-Code
     * @return    string     html-Code                        
     */          
	function killWhiteSpace($html) {    
		$html = $this->convNlOs($html);    
		$temp = explode ($this->newline, $html);
        for ($i = 0; $i < count ($temp); $i++) {
        	if (!trim ($temp[$i])) {
            	unset ($temp[$i]);
            }
            else {
            	$temp[$i] = trim($temp[$i]);
            	$temp[$i] = preg_replace('/\s\s+/', ' ', $temp[$i]);
            }
        }
    	$html = implode($this->newline, $temp);  
        return $html;
    }

	/**
     * help function to formatHtml
     *  removes white space at the end of lines, keeps other white space and line breaks 
     * 
     * @param     string     html-Code
     * @return    string     html-Code                        
     */          
    function rTrimLines($html) {    
    	$html = $this->convNlOs($html);   
        $temp = explode ($this->newline, $html);
        for ($i = 0; $i < count ($temp); $i++) {
        	$temp[$i] = rtrim($temp[$i]);
        }
        $html = implode($this->newline, $temp);  
        return $html;
    }
        
	/*
     * help function to formatHtml
     *  convert newlines according to the current OS 
     * 
     * @param     string     html-Code
     * @return    string     html-Code          
     */
    function convNlOs ($html) {
    	$html = ereg_replace("(\r\n|\n|\r)", $this->newline, $html); 
        return $html;
    }
##################################################################

##################################################################
#### moveInlineCss [old]: ########################################
##################################################################
        /**
        * get all css from the current document, move it all into an external file and do some optimization to the file
        * 
        * @param   nothing
        * @return  nothing                        
        */
        function moveInlineCss () {
                // check, if directory exists
                $path_parts = pathinfo ($this->conf['moveInlineCss.']['file']);
                if (!is_dir (PATH_site.$path_parts['dirname']))
                        debug (array ('The directory "'.$path_parts['dirname'].'" specified for the inline-css-file doesn\'t exist (extension source-optimization)'));
                else {
                        // get all inline-css
                        $num_00 = preg_match_all ("/<style.+?>.+<\/style>/is", $this->head, $matches);     
                        // if there are any reasults, try to open/create the css-file and insert the optimized css into this file
                        if ($num_00) {
                                if (count ($matches[0]) > 1)
                                        $css_content_new = implode ($this->newline, $matches[0]);
                                else
                                        $css_content_new = $matches[0][0];
                                // remove style-tags, html-comments and css-comments
                                $css_content_new = preg_replace ("/<\/style>/i", "", $css_content_new);
                                $css_content_new = preg_replace ("/<style.+?>/i", "", $css_content_new);
                                $css_content_new = str_replace ("<!--", "", $css_content_new);
                                $css_content_new = str_replace ("-->", "", $css_content_new);
                                $css_content_new = preg_replace ("/\/\*.+?\*\//is", "", $css_content_new);                               
                                // optimization of the css
                                $this->trimLines ($css_content_new);
                                $this->removeEmptyLines ($css_content_new);
                                #$this->removeNewLines (&$css_content_new);                             
                                // check, if the css-file already exists: if so, compare the css with the new css and write it if any
                                // chances and of course if no file exists; if they are the same, don't do anything
                                if (!file_exists (PATH_site.$this->conf['moveInlineCss.']['file'])) {
                                        $handle = fopen (PATH_site.$this->conf['moveInlineCss.']['file'], "w+");
                                        fwrite ($handle, $css_content_new);
                                        fclose ($handle);
                                }
                                else if (file_exists (PATH_site.$this->conf['moveInlineCss.']['file'])) {
                                        $handle = fopen (PATH_site.$this->conf['moveInlineCss.']['file'], "r");
                                        if ($handle) {
                                                $file_content = fread ($handle, filesize (PATH_site.$this->conf['moveInlineCss.']['file']));
                                                if ($file_content != $css_content_new) {
                                                        $handle_w = fopen (PATH_site.$this->conf['moveInlineCss.']['file'], "w");
                                                        fwrite ($handle_w, $css_content_new);
                                                        fclose ($handle_w);
                                                }
                                        }
                                        fclose ($handle);
                                }
                            
                                // replace css in source with path to css-file
                                // media:
                                $css_media_cObj = t3lib_div::makeInstance('tslib_cObj');
                                $css_media_cObj->start($GLOBALS['TSFE']->page, 'pages');
                                $css_media = $css_media_cObj->stdWrap($this->conf['moveInlineCss.']['media'],$this->conf['moveInlineCss.']['media.']);
                                $css_media = ($css_media != "") ? ' media="'.$css_media.'"':"";
                                // href:
                                $css_path = 'http://'.t3lib_div::getThisUrl ().$this->conf['moveInlineCss.']['file'];
                                // link
                                $css_link = '<link rel="stylesheet" href="'.$css_path.'"'.$css_media.' />';
                                $this->head = preg_replace ("/<style.+?>.+<\/style>/is", $css_link, $this->head, 1);
                                $this->head = preg_replace ("/<style.+?>.+<\/style>/is", "", $this->head);
                        }
                }
        }
##################################################################

##################################################################
#### small functions [old]: ######################################
##################################################################
		function alternateHtmlXhtmlLanguage () {
                $pattern = "/<html xmlns=\"http\:\/\/www\.w3\.org\/1999\/xhtml\" xml\:lang=\".{2}\" lang=\".{2}\">/is";
                $replacement = "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"".$this->conf['alternateHtmlXhtmlLanguage']."\" lang=\"".$this->conf['alternateHtmlXhtmlLanguage']."\">";
                $this->content = preg_replace ($pattern, $replacement, $this->content);
        }
        
        function replaceDoctype () {
                $this->content = preg_replace ("/<!DOCTYPE.+?>/is", $this->conf['replaceDoctype'], $this->content);
        }
        
        /**
        * removes tabs and empty spaces bevore and after lines, transforms linebreaks system conform
        *         
        * @param    string-reff    Html-Code   
        * @return   nothing             
        */
        function trimLines (&$html) {
                $html = str_replace ("\t", "", $html);       
                // convert newlines according to the current OS
                if (TYPO3_OS == "WIN")
                        $html = str_replace ("\n", "\r\n", $html);
                else
                        $html = str_replace ("\r\n", "\n", $html);
                $temp = explode ($this->newline, $html);
                array_walk ($temp, array($this, 'trimLines_callback') );
                $html = implode ($this->newline, $temp);
                unset ($temp);
        }
        // help function to trimLines
        function trimLines_callback (&$value, $key) {
                $value = trim ($value);
        }
        
        /**
        * removes empty lines
        *         
        * @param    string-reff    html-Code
        * @return   nothing                
        */
        function removeEmptyLines (&$html) {
                $temp = explode ($this->newline, $html);
                for ($i = 0; $i < count ($temp); $i++)
                    if (!trim ($temp[$i]))
                        unset ($temp[$i]);
                $html = implode ($this->newline, $temp);           
        }

        /**
        * removes new lines where unnecessary  
        * spares line breaks within: pre, textarea, ...
        * 
        * @param     string-reff     html-Code
        * @return    nothing                        
        */        
        function removeNewLines (&$html) {
                $splitArray = array('textarea', 'pre'); // eventuell auch: span, script, style
                $peaces = preg_split('#(<('.implode('|', $splitArray).').*>.*</\2>)#Uis', $html, -1, PREG_SPLIT_DELIM_CAPTURE);
                $html = "";
                for ($i=0; $i<count($peaces); $i++){
                        if (($i+1)%3==0) continue;  
                        $html .= (($i-1)%3!=0)?$this->killLineBreaks($peaces[$i]):$peaces[$i];
                }
        }
##################################################################

##################################################################
#### functions [not in use anymore]:  ############################
##################################################################
        /**
        * clean up html-comments
        *         
        * @param    string-reff     html-code
        * @return   nothing                
        */
        function removeComments_old (&$html) {
                //$html = preg_replace ("/<!--.+?-->/is", "", $html);
                $html = $this->CleanComment($html, array('script','style'));
        }             
        // fruit-lab.de
        // removes unnecessary comments 
        // keeps specified comments
        function CleanComment($c,$e,$n='') {
                $p = preg_split('#(<('.implode('|', $e).').*>.*</\2>)#Uis', $c, -1, PREG_SPLIT_DELIM_CAPTURE);
                for ($i=0; $i<count($p); $i++){
                        if (($i+1)%3==0) continue;
                        $n .= (($i-1)%3!=0)?preg_replace_callback('#<!--(.*)-->#Us',array($this,'CleanComment_callback'),$p[$i]):$p[$i];                  
                        # $n .= (($i-1)%3!=0)?preg_replace('#<!--.*-->#Us','',$p[$i]):$p[$i];
                }
                return $n;
        }
        // helpfunction to cleanComment preg_replace_callback        
        function CleanComment_callback($match) {
            if ($this->conf['keepComment.']) 
              foreach($this->conf['keepComment.'] as $pattern) {
                  if(preg_match($pattern,$match[1])) return $match[0];
              }
            else return "";
        }
##################################################################      
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sourceopt/pi1/class.tx_sourceopt_pi1.php"]){
        include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sourceopt/pi1/class.tx_sourceopt_pi1.php"]);
}

?>
